#ifdef ATL_UCLEANN
#define ATL_dJIK62x0x62TN62x62x0_a1_b0 ATL_dgpNBmm_b0
#else
#define ATL_dJIK62x0x62TN62x62x0_a1_b0 ATL_dpNBmm_b0
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK2x0x62TN2x1x1_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=2, NB=0, KB=62, 
 * lda=62, ldb=62, ldc=0, mu=2, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const double *stM = A + 124;
   const double *stN = B + (62*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*1)/(2*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 62, incAn = -124;
   #define incBk 1
   const int incBm = -62, incBn = 62;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (ldc) - 2;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0;
   register double m0;
   register double rC0_0, rC1_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      ATL_pfl1W(pC0);
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[62];
      m0 = rA0 * rB0;

/*
 *    Peel first 1 iterations for C assignment
 */
      rC0_0 = m0;
      m0 = rA1 * rB0;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rA1 = pA0[63];
      rC1_0 = m0;
      m0 = rA0 * rB0;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=0; k < 60; k++) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[63];
         rC1_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         pB0 += incBk;
      } /* end K-loop */
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m0;
      m0 = rA1 * rB0;
      rC1_0 += m0;
      pA0 += incAk0;
      pB0 += incBk0;
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_dJIK62x0x62TN4x1x1_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=62, NB=0, KB=62, 
 * lda=62, ldb=62, ldc=0, mu=4, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 3720;
   const double *stN = B + (62*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*1)/(62*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 186, incAn = -3720;
   #define incBk 1
   const int incBm = -62, incBn = 62;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (ldc) - 60;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0;
   register double m0;
   register double rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         ATL_pfl1W(pC0);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[62];
         rA2 = pA0[124];
         rA3 = pA0[186];
         m0 = rA0 * rB0;

/*
 *       Peel first 1 iterations for C assignment
 */
         rC0_0 = m0;
         m0 = rA1 * rB0;
         rC1_0 = m0;
         m0 = rA2 * rB0;
         rC2_0 = m0;
         m0 = rA3 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[63];
         rA2 = pA0[125];
         rA3 = pA0[187];
         rC3_0 = m0;
         m0 = rA0 * rB0;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=0; k < 60; k++) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[63];
            rA2 = pA0[125];
            rA3 = pA0[187];
            rC3_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rC1_0 += m0;
         m0 = rA2 * rB0;
         rC2_0 += m0;
         m0 = rA3 * rB0;
         rC3_0 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_dJIK2x0x62TN2x1x1_a1_b0(2, N, 62, alpha, ca + 3720, lda, cb, ldb, beta, cc + 60, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK2x0x62TN2x9x1_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=2, NB=0, KB=62, 
 * lda=62, ldb=62, ldc=0, mu=2, nu=9, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N/9)*9;
   const double *stM = A + 124;
   const double *stN = B + (62*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*9)/(2*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 62, incAn = -124;
   #define incBk 1
   const int incBm = -62, incBn = 558;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 3)+ldc) - 2;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc), *pC8=pC7+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8;
   register double m0;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5, rC0_6, rC1_6, rC0_7, rC1_7, rC0_8, rC1_8;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      rC0_1 = *pC1;
      rC0_2 = *pC2;
      rC0_3 = *pC3;
      rC0_4 = *pC4;
      rC0_5 = *pC5;
      rC0_6 = *pC6;
      rC0_7 = *pC7;
      rC0_8 = *pC8;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
      ATL_pfl1W(pC3);
      ATL_pfl1W(pC4);
      ATL_pfl1W(pC5);
      ATL_pfl1W(pC6);
      ATL_pfl1W(pC7);
      ATL_pfl1W(pC8);
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[62];
      rB1 = pB0[62];
      rB2 = pB0[124];
      rB3 = pB0[186];
      m0 = rA0 * rB0;
      rB4 = pB0[248];
      rB5 = pB0[310];
      rB6 = pB0[372];

/*
 *    Peel first 1 iterations for C assignment
 */
      rC0_0 = m0;
      m0 = rA1 * rB0;
      rB7 = pB0[434];
      rB8 = pB0[496];
      rC1_0 = m0;
      m0 = rA0 * rB1;
      rC0_1 = m0;
      m0 = rA1 * rB1;
      rC1_1 = m0;
      m0 = rA0 * rB2;
      rC0_2 = m0;
      m0 = rA1 * rB2;
      rC1_2 = m0;
      m0 = rA0 * rB3;
      rC0_3 = m0;
      m0 = rA1 * rB3;
      rC1_3 = m0;
      m0 = rA0 * rB4;
      rC0_4 = m0;
      m0 = rA1 * rB4;
      rC1_4 = m0;
      m0 = rA0 * rB5;
      rC0_5 = m0;
      m0 = rA1 * rB5;
      rC1_5 = m0;
      m0 = rA0 * rB6;
      rC0_6 = m0;
      m0 = rA1 * rB6;
      rC1_6 = m0;
      m0 = rA0 * rB7;
      rC0_7 = m0;
      m0 = rA1 * rB7;
      rC1_7 = m0;
      m0 = rA0 * rB8;
      rC0_8 = m0;
      m0 = rA1 * rB8;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rA1 = pA0[63];
      rB1 = pB0[63];
      rB2 = pB0[125];
      rB3 = pB0[187];
      rB4 = pB0[249];
      rB5 = pB0[311];
      rB6 = pB0[373];
      rC1_8 = m0;
      m0 = rA0 * rB0;
      rB7 = pB0[435];
      rB8 = pB0[497];
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=0; k < 60; k++) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA1 * rB0;
         rC1_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA1 * rB1;
         rC1_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA1 * rB2;
         rC1_2 += m0;
         m0 = rA0 * rB3;
         rC0_3 += m0;
         m0 = rA1 * rB3;
         rC1_3 += m0;
         m0 = rA0 * rB4;
         rC0_4 += m0;
         m0 = rA1 * rB4;
         rC1_4 += m0;
         m0 = rA0 * rB5;
         rC0_5 += m0;
         m0 = rA1 * rB5;
         rC1_5 += m0;
         m0 = rA0 * rB6;
         rC0_6 += m0;
         m0 = rA1 * rB6;
         rC1_6 += m0;
         m0 = rA0 * rB7;
         rC0_7 += m0;
         m0 = rA1 * rB7;
         rC1_7 += m0;
         m0 = rA0 * rB8;
         rC0_8 += m0;
         m0 = rA1 * rB8;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[63];
         rB1 = pB0[63];
         rB2 = pB0[125];
         rB3 = pB0[187];
         rB4 = pB0[249];
         rB5 = pB0[311];
         rB6 = pB0[373];
         rC1_8 += m0;
         m0 = rA0 * rB0;
         rB7 = pB0[435];
         rB8 = pB0[497];
         pA0 += incAk;
         pB0 += incBk;
      } /* end K-loop */
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m0;
      m0 = rA1 * rB0;
      rC1_0 += m0;
      m0 = rA0 * rB1;
      rC0_1 += m0;
      m0 = rA1 * rB1;
      rC1_1 += m0;
      m0 = rA0 * rB2;
      rC0_2 += m0;
      m0 = rA1 * rB2;
      rC1_2 += m0;
      m0 = rA0 * rB3;
      rC0_3 += m0;
      m0 = rA1 * rB3;
      rC1_3 += m0;
      m0 = rA0 * rB4;
      rC0_4 += m0;
      m0 = rA1 * rB4;
      rC1_4 += m0;
      m0 = rA0 * rB5;
      rC0_5 += m0;
      m0 = rA1 * rB5;
      rC1_5 += m0;
      m0 = rA0 * rB6;
      rC0_6 += m0;
      m0 = rA1 * rB6;
      rC1_6 += m0;
      m0 = rA0 * rB7;
      rC0_7 += m0;
      m0 = rA1 * rB7;
      rC1_7 += m0;
      m0 = rA0 * rB8;
      rC0_8 += m0;
      m0 = rA1 * rB8;
      rC1_8 += m0;
      pA0 += incAk0;
      pB0 += incBk0;
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      *pC4 = rC0_4;
      pC4[1] = rC1_4;
      *pC5 = rC0_5;
      pC5[1] = rC1_5;
      *pC6 = rC0_6;
      pC6[1] = rC1_6;
      *pC7 = rC0_7;
      pC7[1] = rC1_7;
      *pC8 = rC0_8;
      pC8[1] = rC1_8;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pC4 += incCm;
      pC5 += incCm;
      pC6 += incCm;
      pC7 += incCm;
      pC8 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pC8 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK62x0x62TN62x62x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=62, NB=0, KB=62, 
 * lda=62, ldb=62, ldc=0, mu=4, nu=9, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N/9)*9;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 3720;
   const double *stN = B + (62*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*9)/(62*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 186, incAn = -3720;
   #define incBk 1
   const int incBm = -62, incBn = 558;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 3)+ldc) - 60;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc), *pC8=pC7+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8;
   register double m0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3, rC0_4, rC1_4, rC2_4, rC3_4, rC0_5, rC1_5, rC2_5, rC3_5, rC0_6, rC1_6, rC2_6, rC3_6, rC0_7, rC1_7, rC2_7, rC3_7, rC0_8, rC1_8, rC2_8, rC3_8;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            ATL_pfl1R(pfA+ATL_L1LS);
            pfA += incPFA;
/*
 *          Feeble prefetch of C
 */
            rC0_0 = *pC0;
            rC0_1 = *pC1;
            rC0_2 = *pC2;
            rC0_3 = *pC3;
            rC0_4 = *pC4;
            rC0_5 = *pC5;
            rC0_6 = *pC6;
            rC0_7 = *pC7;
            rC0_8 = *pC8;
            ATL_pfl1W(pC0);
            ATL_pfl1W(pC1);
            ATL_pfl1W(pC2);
            ATL_pfl1W(pC3);
            ATL_pfl1W(pC4);
            ATL_pfl1W(pC5);
            ATL_pfl1W(pC6);
            ATL_pfl1W(pC7);
            ATL_pfl1W(pC8);
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[62];
            rA2 = pA0[124];
            rA3 = pA0[186];
            rB1 = pB0[62];
            m0 = rA0 * rB0;
            rB2 = pB0[124];
            rB3 = pB0[186];
            rB4 = pB0[248];

/*
 *          Peel first 1 iterations for C assignment
 */
            rC0_0 = m0;
            m0 = rA1 * rB0;
            rB5 = pB0[310];
            rB6 = pB0[372];
            rB7 = pB0[434];
            rC1_0 = m0;
            m0 = rA2 * rB0;
            rB8 = pB0[496];
            rC2_0 = m0;
            m0 = rA3 * rB0;
            rC3_0 = m0;
            m0 = rA0 * rB1;
            rC0_1 = m0;
            m0 = rA1 * rB1;
            rC1_1 = m0;
            m0 = rA2 * rB1;
            rC2_1 = m0;
            m0 = rA3 * rB1;
            rC3_1 = m0;
            m0 = rA0 * rB2;
            rC0_2 = m0;
            m0 = rA1 * rB2;
            rC1_2 = m0;
            m0 = rA2 * rB2;
            rC2_2 = m0;
            m0 = rA3 * rB2;
            rC3_2 = m0;
            m0 = rA0 * rB3;
            rC0_3 = m0;
            m0 = rA1 * rB3;
            rC1_3 = m0;
            m0 = rA2 * rB3;
            rC2_3 = m0;
            m0 = rA3 * rB3;
            rC3_3 = m0;
            m0 = rA0 * rB4;
            rC0_4 = m0;
            m0 = rA1 * rB4;
            rC1_4 = m0;
            m0 = rA2 * rB4;
            rC2_4 = m0;
            m0 = rA3 * rB4;
            rC3_4 = m0;
            m0 = rA0 * rB5;
            rC0_5 = m0;
            m0 = rA1 * rB5;
            rC1_5 = m0;
            m0 = rA2 * rB5;
            rC2_5 = m0;
            m0 = rA3 * rB5;
            rC3_5 = m0;
            m0 = rA0 * rB6;
            rC0_6 = m0;
            m0 = rA1 * rB6;
            rC1_6 = m0;
            m0 = rA2 * rB6;
            rC2_6 = m0;
            m0 = rA3 * rB6;
            rC3_6 = m0;
            m0 = rA0 * rB7;
            rC0_7 = m0;
            m0 = rA1 * rB7;
            rC1_7 = m0;
            m0 = rA2 * rB7;
            rC2_7 = m0;
            m0 = rA3 * rB7;
            rC3_7 = m0;
            m0 = rA0 * rB8;
            rC0_8 = m0;
            m0 = rA1 * rB8;
            rC1_8 = m0;
            m0 = rA2 * rB8;
            rC2_8 = m0;
            m0 = rA3 * rB8;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[63];
            rA2 = pA0[125];
            rA3 = pA0[187];
            rB1 = pB0[63];
            rB2 = pB0[125];
            rB3 = pB0[187];
            rB4 = pB0[249];
            rC3_8 = m0;
            m0 = rA0 * rB0;
            rB5 = pB0[311];
            rB6 = pB0[373];
            rB7 = pB0[435];
            pA0 += incAk;
            pB0 += incBk;
/*
 *          Unpeeled K iterations
 */
            for (k=0; k < 60; k++) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rB8 = pB0[496];
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rC3_0 += m0;
               m0 = rA0 * rB1;
               rC0_1 += m0;
               m0 = rA1 * rB1;
               rC1_1 += m0;
               m0 = rA2 * rB1;
               rC2_1 += m0;
               m0 = rA3 * rB1;
               rC3_1 += m0;
               m0 = rA0 * rB2;
               rC0_2 += m0;
               m0 = rA1 * rB2;
               rC1_2 += m0;
               m0 = rA2 * rB2;
               rC2_2 += m0;
               m0 = rA3 * rB2;
               rC3_2 += m0;
               m0 = rA0 * rB3;
               rC0_3 += m0;
               m0 = rA1 * rB3;
               rC1_3 += m0;
               m0 = rA2 * rB3;
               rC2_3 += m0;
               m0 = rA3 * rB3;
               rC3_3 += m0;
               m0 = rA0 * rB4;
               rC0_4 += m0;
               m0 = rA1 * rB4;
               rC1_4 += m0;
               m0 = rA2 * rB4;
               rC2_4 += m0;
               m0 = rA3 * rB4;
               rC3_4 += m0;
               m0 = rA0 * rB5;
               rC0_5 += m0;
               m0 = rA1 * rB5;
               rC1_5 += m0;
               m0 = rA2 * rB5;
               rC2_5 += m0;
               m0 = rA3 * rB5;
               rC3_5 += m0;
               m0 = rA0 * rB6;
               rC0_6 += m0;
               m0 = rA1 * rB6;
               rC1_6 += m0;
               m0 = rA2 * rB6;
               rC2_6 += m0;
               m0 = rA3 * rB6;
               rC3_6 += m0;
               m0 = rA0 * rB7;
               rC0_7 += m0;
               m0 = rA1 * rB7;
               rC1_7 += m0;
               m0 = rA2 * rB7;
               rC2_7 += m0;
               m0 = rA3 * rB7;
               rC3_7 += m0;
               m0 = rA0 * rB8;
               rC0_8 += m0;
               m0 = rA1 * rB8;
               rC1_8 += m0;
               m0 = rA2 * rB8;
               rC2_8 += m0;
               m0 = rA3 * rB8;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[63];
               rA2 = pA0[125];
               rA3 = pA0[187];
               rB1 = pB0[63];
               rB2 = pB0[125];
               rB3 = pB0[187];
               rB4 = pB0[249];
               rC3_8 += m0;
               m0 = rA0 * rB0;
               rB5 = pB0[311];
               rB6 = pB0[373];
               rB7 = pB0[435];
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rB8 = pB0[496];
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            m0 = rA0 * rB1;
            rC0_1 += m0;
            m0 = rA1 * rB1;
            rC1_1 += m0;
            m0 = rA2 * rB1;
            rC2_1 += m0;
            m0 = rA3 * rB1;
            rC3_1 += m0;
            m0 = rA0 * rB2;
            rC0_2 += m0;
            m0 = rA1 * rB2;
            rC1_2 += m0;
            m0 = rA2 * rB2;
            rC2_2 += m0;
            m0 = rA3 * rB2;
            rC3_2 += m0;
            m0 = rA0 * rB3;
            rC0_3 += m0;
            m0 = rA1 * rB3;
            rC1_3 += m0;
            m0 = rA2 * rB3;
            rC2_3 += m0;
            m0 = rA3 * rB3;
            rC3_3 += m0;
            m0 = rA0 * rB4;
            rC0_4 += m0;
            m0 = rA1 * rB4;
            rC1_4 += m0;
            m0 = rA2 * rB4;
            rC2_4 += m0;
            m0 = rA3 * rB4;
            rC3_4 += m0;
            m0 = rA0 * rB5;
            rC0_5 += m0;
            m0 = rA1 * rB5;
            rC1_5 += m0;
            m0 = rA2 * rB5;
            rC2_5 += m0;
            m0 = rA3 * rB5;
            rC3_5 += m0;
            m0 = rA0 * rB6;
            rC0_6 += m0;
            m0 = rA1 * rB6;
            rC1_6 += m0;
            m0 = rA2 * rB6;
            rC2_6 += m0;
            m0 = rA3 * rB6;
            rC3_6 += m0;
            m0 = rA0 * rB7;
            rC0_7 += m0;
            m0 = rA1 * rB7;
            rC1_7 += m0;
            m0 = rA2 * rB7;
            rC2_7 += m0;
            m0 = rA3 * rB7;
            rC3_7 += m0;
            m0 = rA0 * rB8;
            rC0_8 += m0;
            m0 = rA1 * rB8;
            rC1_8 += m0;
            m0 = rA2 * rB8;
            rC2_8 += m0;
            m0 = rA3 * rB8;
            rC3_8 += m0;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            *pC1 = rC0_1;
            pC1[1] = rC1_1;
            pC1[2] = rC2_1;
            pC1[3] = rC3_1;
            *pC2 = rC0_2;
            pC2[1] = rC1_2;
            pC2[2] = rC2_2;
            pC2[3] = rC3_2;
            *pC3 = rC0_3;
            pC3[1] = rC1_3;
            pC3[2] = rC2_3;
            pC3[3] = rC3_3;
            *pC4 = rC0_4;
            pC4[1] = rC1_4;
            pC4[2] = rC2_4;
            pC4[3] = rC3_4;
            *pC5 = rC0_5;
            pC5[1] = rC1_5;
            pC5[2] = rC2_5;
            pC5[3] = rC3_5;
            *pC6 = rC0_6;
            pC6[1] = rC1_6;
            pC6[2] = rC2_6;
            pC6[3] = rC3_6;
            *pC7 = rC0_7;
            pC7[1] = rC1_7;
            pC7[2] = rC2_7;
            pC7[3] = rC3_7;
            *pC8 = rC0_8;
            pC8[1] = rC1_8;
            pC8[2] = rC2_8;
            pC8[3] = rC3_8;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pC6 += incCm;
            pC7 += incCm;
            pC8 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pC6 += incCn;
         pC7 += incCn;
         pC8 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_dJIK62x0x62TN4x1x1_a1_b0(62, k, 62, alpha, ca, lda, cb + (62*(Nb)), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb)

      ATL_dJIK2x0x62TN2x9x1_a1_b0(2, Nb, 62, alpha, ca + 3720, lda, cb, ldb, beta, cc + 60, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
